// THE GAME ITSELF

import { Player } from './player';
import { Terrain } from './terrain';

// this class extends Scene class
export class PlayGame extends Phaser.Scene {

    constructor() {
        super({
            key : 'PlayGame'
        });
    }

    player : Player;
    terrain : Terrain;

    // method to be executed when the scene has been created
    create() : void {        
        this.terrain = new Terrain(this);
        this.player = new Player(this);
        this.input.on('pointerdown', this.handleInput, this);
        this.player.on('toolow', this.scrollTerrain, this); 
        
    }

    handleInput(pointer : Phaser.Input.Pointer) : void {
        this.player.move(pointer.x < (this.game.config.width as number / 2));      
    }

    scrollTerrain(delta : number) : void {
        Phaser.Actions.IncY(this.terrain.getChildren(), delta);
    }

    update() : void {
        this.player.updatePosition();
        this.terrain.updatePosition();
    }
}