// TERRAIN CLASS EXTENDS PHASER.GAMEOBJECTS.GROUP

import { GameOptions } from './gameOptions';
import { Tile } from './tile';

export class Terrain extends Phaser.GameObjects.Group {
 
    constructor(scene : Phaser.Scene) {
        super(scene);
        scene.add.existing(this);
        for (let i : number = 0; i < GameOptions.gridSize.y; i ++) {
            this.addRow(i);
        }
    }

    addRow(i : number) : void {
        let offset : number = (this.scene.game.config.width as number - GameOptions.gridSize.x * GameOptions.hexagon.width) / 2;
        for (let j : number = 0; j < GameOptions.gridSize.x - i % 2; j ++) {
            let hexagonX : number = GameOptions.hexagon.width * j + (GameOptions.hexagon.width / 2) * (i % 2) + offset;
            let hexagonY : number = GameOptions.scrollY + GameOptions.hexagon.height * i / 4 * 3;
            let tile : Tile = new Tile(this.scene, hexagonX, hexagonY)
            this.add(tile);
        }
    }

    updatePosition() : void {
        this.getChildren().forEach((child : Phaser.GameObjects.GameObject) => {
            let tile : Tile = child as Tile;
            tile.updatePosition();
        })
    }
}